freeslot("MT_SONICSPRING", "MT_SONICDIAG")

mobjinfo[MT_SONICSPRING] = {
	doomednum = -1,
	spawnstate = S_REDSPRING,
	spawnhealth = 1000,
	painsound = sfx_spring,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 15*FRACUNIT,
	flags = MF_SPRING,
	raisestate = S_REDSPRING2
}

mobjinfo[MT_SONICDIAG] = {
	doomednum = -1,
	spawnstate = S_RDIAG1,
	spawnhealth = 1000,
	painsound = sfx_spring,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 15*FRACUNIT,
	damage = 42*FRACUNIT,
	flags = MF_SPRING,
	raisestate = S_RDIAG2
}

local function SpawnSonicSpring(player, diag)
	local diagspr = MT_SONICSPRING
	local diagst = S_REDSPRING2
	if diag
		diagspr = MT_SONICDIAG
		diagst = S_RDIAG2
	else
		diagspr = MT_SONICSPRING
		diagst = S_REDSPRING2
	end
	local spring = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, diagspr)
	spring.target = player.mo
	spring.fuckyouitsmisc = true
	spring.startang = 1
	spring.fuse = TICRATE
	spring.dissappear = TICRATE
	spring.state = diagst	
	spring.angle = player.drawangle
	spring.startang = 1
	if P_RandomRange(1, 2) == 1
		spring.startang = 1
	else
		spring.startang = -1
	end
	player.whatsprung = 5
	return spring
end

addHook("ShieldSpecial", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == "sonicnew"
		if not (player.cmd.buttons & BT_JUMP)
			return true
		end
	end
end)

addHook("AbilitySpecial", function(player) //Fuck you spring is mostly a cosmetic
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == "sonicnew"
		if not player.usedspring
		and not player.wallCling
			player.usedspring = true
			SpawnSonicSpring(player)
		end	
	end
end)

local byebye = {
	[0] = FF_FULLBRIGHT,
	[1] = FF_TRANS90,
	[2] = FF_TRANS80,
	[3] = FF_TRANS70,
	[4] = FF_TRANS60,
	[5] = FF_TRANS50,
	[6] = FF_TRANS40,
	[7] = FF_TRANS30,
	[8] = FF_TRANS20,
	[9] = FF_TRANS10
}

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.type == MT_SONICSPRING
		or mo.type == MT_SONICDIAG
		and mo.fuckyouitsmisc
			if not P_IsObjectOnGround(mo)
				mo.momzforwhat = mo.momz
				mo.flags = $|MF_NOCLIP|MF_NOCLIPTHING
			else
				mo.momzforwhat = $ - gravity
				mo.spriteyoffset = $ + mo.momzforwhat
			end
			if mo.startang
				mo.rollangle = $ + mo.momz/FRACUNIT*ANG1*mo.startang
			end	
			if mo.dissappear 
				mo.dissappear = $ - 1
				if mo.dissappear < 10
					local bop = byebye[mo.dissappear]
					mo.frame = $|bop
				end
			end	
		end
	end
end)

addHook("MobjLineCollide", function(mo, line)
	if mo and mo.valid and line and line.valid and mo.player and mo.player.valid
	and mo.skin == "sonicnew"
		mo.player.clastlinehit = line
	end
end)

addHook("MobjMoveBlocked", function(mo)
	if mo and mo.valid
		if mo.type == MT_PLAYER and mo.player
		and mo.skin == "sonicnew"
			if mo.player.clastlinehit
				if (mo.player.pflags & PF_JUMPED or mo.player.freefall)
				and not mo.player.cantWall
				//and not (mo.player.clastlinehit.flags & ML_NOCLIMB)
					mo.player.wallJumped = 0
					local angle = R_PointToAngle2(0, 0, mo.player.clastlinehit.dx, mo.player.clastlinehit.dy)
					mo.player.wallLastAng = angle
					if P_PointOnLineSide(mo.x, mo.y, mo.player.clastlinehit) == 0
						mo.player.wallAng = angle+ANGLE_90+ANGLE_180
						if mo.player.clastlinehit.frontside
							local side = mo.player.clastlinehit.frontside
							local invside = mo.player.clastlinehit.backside
							if invside and invside.sector and mo.z >= invside.sector.ceilingheight
								if not side.toptexture
									mo.player.cantClimb = true
								end
							end
							if invside and invside.sector and mo.z < invside.sector.ceilingheight
								if not side.bottomtexture
									mo.player.cantClimb = true
								end
							end
							if not side.toptexture
							and not side.midtexture
							and not side.bottomtexture
								mo.player.cantClimb = true
							end
						end
					else
						mo.player.wallAng = angle-ANGLE_90+ANGLE_180
						if mo.player.clastlinehit.backside
							local side = mo.player.clastlinehit.backside
							local invside = mo.player.clastlinehit.frontside
							if invside and invside.sector and mo.z >= invside.sector.ceilingheight
								if not side.toptexture
									mo.player.cantClimb = true
								end
							end	
							if invside and invside.sector and mo.z < invside.sector.ceilingheight
								if not side.bottomtexture
									mo.player.cantClimb = true
								end
							end
							if not side.toptexture
							and not side.midtexture
							and not side.bottomtexture
								mo.player.cantClimb = true
							end
						end	
					end
					if mo.momz*P_MobjFlip(mo) <= FRACUNIT
					and not mo.player.cantClimb
						mo.player.wallCling = 5
						mo.player.usedspring = false
						mo.state = S_PLAY_FALL
						local dust = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_DUST)
						dust.fuse = 15
						P_Thrust(dust, angle, P_RandomRange(-5, 5)*FRACUNIT)
						local player = mo.player
						if (player.cmd.sidemove or player.cmd.forwardmove)
						and player.ctrlAng
							P_Thrust(player.mo, player.ctrlAng, FRACUNIT)
						end
						if P_PointOnLineSide(mo.x, mo.y, mo.player.clastlinehit) == 0
							mo.player.drawangle = angle+ANGLE_90+ANGLE_180
							P_Thrust(mo, angle+ANGLE_90, FRACUNIT*2)
							P_Thrust(dust, angle+ANGLE_90, FRACUNIT*2)
						else
							mo.player.drawangle = angle-ANGLE_90+ANGLE_180
							P_Thrust(mo, angle-ANGLE_90, FRACUNIT*2)
							P_Thrust(dust, angle-ANGLE_90, FRACUNIT*2)
						end
						if mo.momz*P_MobjFlip(mo) <= -5*FRACUNIT
							P_SetObjectMomZ(mo, -5*FRACUNIT)
						end
					end
				end	
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == "sonicnew"
		player.spindashcharge = $ or player.mindash
		player.whatsprung = $ or 0
		if player.whatsprung
			player.whatsprung = $ - 1
		end
		if player.mo.eflags & MFE_SPRUNG
			player.freefall = true
		end	
		player.charge = $ or 0
		player.downair = $ or 0
		player.spincd = $ or 0
		if player.charge
			player.charge = $ - 1
		end
		if player.spincd
			player.spincd = $ - 1
		end
		if player.downair
			player.downair = $ - 1
		end
		player.ctrlAng = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
		if player.wallCling
			player.wallCling = $ - 1
			if player.cmd.buttons & BT_JUMP
				if not player.wall
				or (player.wall and player.wall <= 5)
				and player.wallAng
				and not player.cantClimb
				and not player.cantWall
					player.mo.state = S_PLAY_JUMP
					player.pflags = $|PF_JUMPED
					player.cantWall = 5
					player.drawangle = player.wallAng
					P_Thrust(player.mo, player.wallAng, 24*FRACUNIT)
					P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
					player.freefall = false
				end
			end
			if player.pflags & PF_THOKKED
				player.pflags = $ & ~PF_THOKKED
			end
		else
			if player.cantClimb
				player.cantClimb = false
			end
		end
		if player.cantWall
			player.cantWall = $ - 1
		end
		if player.cmd.buttons & BT_SPIN //https://www.youtube.com/watch?v=czhd1eHv6ac this is so messy
			if not player.dash
			and P_IsObjectOnGround(player.mo)
			and ((player.pflags & PF_SPINNING) or (player.pflags & PF_STARTDASH))
			and not player.spincd
				player.spincd = 2
				player.mo.state = S_PLAY_WALK
				player.pflags = $&~(PF_SPINNING|PF_STARTDASH)
			end
			if not player.dash
			and P_IsObjectOnGround(player.mo)
			and not ((player.pflags & PF_SPINNING) or (player.pflags & PF_STARTDASH))
			and not player.spincd
				player.spincd = 2
				player.spedchr = player.speed
				if player.speed <= 60*FRACUNIT
					if player.speed < player.mindash
						player.spindashcharge = player.mindash
					else
						player.spindashcharge = player.speed
					end	
				end
				player.charge = 5
			end
			if player.dash
			and player.spindashcharge
			and player.charge
				player.charge = 5
				player.dashspeed = player.spindashcharge
				if player.spindashcharge < 60*FRACUNIT
					player.spindashcharge = $ + FRACUNIT
					S_StartSound(player.mo, sfx_spndsh)
				end	
				if P_IsObjectOnGround(player.mo) //Ok who tf made the spindash code that unportable to lua?
					if player.mo.state != S_PLAY_SPINDASH
						player.mo.state = S_PLAY_SPINDASH
					end	
					player.pflags = $|PF_SPINNING|PF_STARTDASH
				else
					if player.powers[pw_shield] == SH_WHIRLWIND
						P_SetObjectMomZ(player.mo, FRACUNIT/5, true)
					end
					local ghost = P_SpawnGhostMobj(player.mo)
					ghost.blendmode = AST_ADD
					P_InstaThrust(ghost, P_RandomRange(1, 360)*ANG1, P_RandomRange(0, 15)*FRACUNIT)
					P_SetObjectMomZ(ghost, P_RandomRange(-5, 5)*FRACUNIT)
					player.pflags = $&~(PF_SPINNING|PF_STARTDASH)
				end	
			end
			if not player.dash
			and not P_IsObjectOnGround(player.mo)
			and player.freefall and not player.spincd
			and not player.wallCling
			and ((player.pflags & PF_SPINNING) or not (player.pflags & PF_JUMPED))
			and not (player.powers[pw_shield] and player.cmd.buttons & BT_JUMP)
				player.pflags = $|PF_JUMPED
				if not (player.pflags & PF_SPINNING)
					S_StartSound(player.mo, sfx_spin)
				else
					S_StartSound(player.mo, sfx_kc59)
				end
				player.pflags = $ & ~(PF_THOKKED|PF_SPINNING)
				player.mo.state = S_PLAY_ROLL
				player.freefall = false
				player.spincd = 5
			end
			if not player.dash
			and not P_IsObjectOnGround(player.mo)
			and not player.freefall 
			and not (player.pflags & PF_THOKKED)
			and not player.spincd
			and not player.wallCling
				player.spincd = 5
				player.pflags = $|PF_JUMPED
				player.pflags = $|PF_THOKKED|PF_SPINNING
				player.mo.state = S_PLAY_ROLL
				S_StartSound(player.mo, sfx_pudpud)
				S_StartSound(player.mo, sfx_thok)
				P_Thrust(player.mo, player.mo.angle, 15*FRACUNIT)
				if player.mo.momz*P_MobjFlip(player.mo) < -15*FRACUNIT
					P_SetObjectMomZ(player.mo, -15*FRACUNIT, true)
				else
					P_SetObjectMomZ(player.mo, -15*FRACUNIT, false)
				end	
				player.downair = TICRATE
			end
			player.dash = true
		else
			if player.dash
			and player.spindashcharge
			and player.charge
				P_InstaThrust(player.mo, player.mo.angle, player.spindashcharge)
				player.pflags = $|PF_SPINNING
				player.pflags = $&~PF_STARTDASH
				player.mo.state = S_PLAY_ROLL
				S_StartSound(player.mo, sfx_zoom)
			end
			player.dash = false
		end	
		if P_IsObjectOnGround(player.mo)
			player.usedspring = false
			player.freefall = false
			player.whatsprung = 0
			player.bufferspring = false
		else
			if not (player.pflags & PF_JUMPED)
				player.freefall = true
			end
		end
		player.wall = $ or 0
		if player.cmd.buttons & BT_JUMP
			player.wall = $ + 1
		else
			player.wall = 0
		end
		player.clastlinehit = nil
	end
end)

addHook("PlayerSpawn", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == "sonicnew"
		player.dashsped = 0
		player.freefall = false
		player.usedspring = false
		player.whatsprung = 0
		player.spindashcharge = player.mindash
		player.charge = 0
		player.wallCling = 0
		player.cantWall = 0
		player.cantClimb = false
		player.wallJumped = 0
		player.friction = 29*FRACUNIT/32
		player.celcd = 0
		player.ceilingd = false
		player.flipgrav = 0
		player.jumpfly = TICRATE/2*3
	end
end)