local function AscendToCeiling(player)
	if player.pflags & (PF_JUMPED|PF_STARTJUMP)
	and player.cmd.buttons & BT_JUMP
	and player.jumpfly
		P_SetObjectMomZ(player.mo, FRACUNIT/5*3, true)
		player.jumpfly = $ - 1
	end
end

local function CeilingRun(player)
	if P_MobjFlip(player.mo) == 1
		player.mo.eflags = $|MFE_VERTICALFLIP
		player.mo.flags2 = $|MF2_OBJECTFLIP
	else
		player.mo.eflags = $&~MFE_VERTICALFLIP
		player.mo.flags2 = $&~MF2_OBJECTFLIP
	end
	player.ceilingd = true
	player.celcd = 15
end

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == "sonicnew"
		local cel = player.mo.ceilingz
		if P_MobjFlip(player.mo) == 1
			cel = player.mo.ceilingz
		else
			cel = player.mo.floorz
		end
		player.celcd = $ or 0
		//player.flipgrav = $ or 0
		if player.celcd
			player.celcd = $ - 1
		end
		/*if player.flipgrav 
			player.flipgrav = $ - 1
		end
		if player.cmd.buttons & BT_SPIN
			if not player.flip
			and not P_IsObjectOnGround(player.mo)
			and player.flipgrav
				player.mo.momz = $*-1
			end
			player.flip = true
		else
			player.flip = false
		end*/
		if player.ceilingd
			player.friction = FRACUNIT*5
		else
			player.friction = 29*FRACUNIT/32
		end
		if player.ceilingd
			if not P_IsObjectOnGround(player.mo)
			or player.speed <= (skins[player.mo.skin].runspeed - 16*FRACUNIT)
				if P_MobjFlip(player.mo) == 1
					player.mo.eflags = $|MFE_VERTICALFLIP
					player.mo.flags2 = $|MF2_OBJECTFLIP
				else
					player.mo.eflags = $&~MFE_VERTICALFLIP
					player.mo.flags2 = $&~MF2_OBJECTFLIP
				end
				player.ceilingd = false
				player.flipgrav = TICRATE
			end
		end
		player.jumpfly = $ or 0
		if P_IsObjectOnGround(player.mo)
			player.jumpfly = TICRATE/2*3
		end
		if player.mo.z >= (cel - (150*FRACUNIT*P_MobjFlip(player.mo)))
		and player.mo.momz*P_MobjFlip(player.mo) >= 0
		and player.speed >= skins[player.mo.skin].runspeed
		and not player.celcd and not player.ceilingd
			local pic //Dont mind if i do
			local rover = player.mo.floorrover or player.mo.ceilingrover
			if rover and rover.valid
				local pic = "toppic" or "bottompic"
				if not rover[pic]:upper():find("F_SKY")
					AscendToCeiling(player)
				end
			else
				local sec = player.mo.subsector.sector
				local pic = "floorpic" or "ceilingpic"
				if not sec[pic]:upper():find("F_SKY")
					AscendToCeiling(player)
				end
			end
		end
		if player.mo.z >= (cel - (player.mo.height*P_MobjFlip(player.mo)))
		and player.mo.momz*P_MobjFlip(player.mo) >= 0
		and player.speed >= skins[player.mo.skin].runspeed
		and not player.celcd and not player.ceilingd
			local pic //Dont mind if i do
			local rover = player.mo.floorrover or player.mo.ceilingrover
			if rover and rover.valid
				local pic = "toppic" or "bottompic"
				if not rover[pic]:upper():find("F_SKY")
					CeilingRun(player)
				end
			else
				local sec = player.mo.subsector.sector
				local pic = "floorpic" or "ceilingpic"
				if not sec[pic]:upper():find("F_SKY")
					CeilingRun(player)
				end
			end
		end
	end
end)